--WHEN ADDING:
	--REPUTATION - Add the reputation to the Reputations list (one of the 3) and to Reputation Levels in UI.lua
	--GEAR TOKEN - Add the tier to the TierTypes list, add the new tokens in the "TOKENS" section, add another "elseif" to the Gear Tokens function below, add the new tier to the "Tier Tokens" in UI.lua
	--RAIDS      - Add the raid to the raid list, add the raid & its bosses in the "BOSSES" section, add a function in the "CONSTRUCTORS" section under the "RAIDS" heading, add two elseif statements in UI.lua for the normal & heroic versions
	--DUNGEONS   - Add the dungeon to the heroic only dungeons or the other dungeon list, add the dungeon & its bosses int he "BOSSES" section, add a function in the "CONSTRUCTORS" section under the appropriate heading, add one or two elseif statements in UI.lua depending on if the dungeon has both a normal & heroic mode or not
	--(Other)    - Add the other things to the list they belong to

local mod = UpgradeList:NewModule("ItemLocations")

local UPGRADELIST_VERSION = GetAddOnMetadata('UpgradeList', 'Version')

local GeneralItemLocations = {
	"Raid",
	"Dungeon",
	"Crafted",
	"Quest Reward",
	"Reputation Reward",
	"Purchasable",
	"World Drop",
	"Other"
};
	
local InstanceTypes = {
	"Heroic",
	"Normal"
};

local Professions = {
	"Archaeology",
	"Alchemy",
	"Blacksmithing",
	"Enchanting",
	"Engineering",
	"Inscription",
	"Jewelcrafting",
	"Leatherworking",
	"Tailoring"
};

local Reputations = {
	"Avengers of Hyjal",
	"Guardians of Hyjal",
	"The Earthen Ring",
	"Therazane",
	"Ramkahen",
};

local AllianceReputations = {
	"Wildhammer Clan",
	"Baradin's Wardens",
};

local HordeReputations = {
	"Dragonmaw Clan",
	"Hellscream's Reach",
};

local ReputationLevels = {
	"Exalted",
	"Revered",
	"Honored",
	"Friendly"
};

local Currency = {
	"Gear Token",
	"Valor Points",
	"Justice Points",
	"Conquest Points",
	"Honor Points"
};

local TierTypes = {
	"Tier 12",
	"Tier 11"
};
----------------------------------------------TOKENS---------------------------------------------
local Tier11Tokens = {
	DDMR = { --Death Knight, Druid, Mage, Rogue
		{ "Crown of the Forlorn Vanquisher", "Nefarian or \"Essence of the Forlorn\" token", "Heroic" },
		{ "Shoulders of the Forlorn Vanquisher", "Cho'gall or \"Essence of the Forlorn\" token", "Heroic" },
		{ "Chest of the Forlorn Vanquisher", "Halfus Wyrmbreaker or \"Essence of the Forlorn\" token", "Heroic" },
		{ "Gauntlets of the Forlorn Vanquisher", "Magmaw or \"Essence of the Forlorn\" token", "Heroic" },
		{ "Leggings of the Forlorn Vanquisher", "Maloriak or \"Essence of the Forlorn\" token", "Heroic" },
		{ "Helm of the Forlorn Vanquisher", "Nefarian", "Normal" },
		{ "Mantle of the Forlorn Vanquisher", "Cho'gall", "Normal" }
	},
	PPW = { --Paladin, Priest, Warlock
		{ "Crown of the Forlorn Conqueror", "Nefarian or \"Essence of the Forlorn\" token", "Heroic" },
		{ "Shoulders of the Forlorn Conqueror", "Cho'gall or \"Essence of the Forlorn\" token", "Heroic" },
		{ "Chest of the Forlorn Conqueror", "Halfus Wyrmbreaker or \"Essence of the Forlorn\" token", "Heroic" },
		{ "Gauntlets of the Forlorn Conqueror", "Magmaw or \"Essence of the Forlorn\" token", "Heroic" },
		{ "Leggings of the Forlorn Conqueror", "Maloriak or \"Essence of the Forlorn\" token", "Heroic" },
		{ "Helm of the Forlorn Conqueror", "Nefarian", "Normal" },
		{ "Mantle of the Forlorn Conqueror", "Cho'gall", "Normal" }
	},
	HSW = { --Hunter, Shaman, Warrior
		{ "Crown of the Forlorn Protector", "Nefarian or \"Essence of the Forlorn\" token", "Heroic" },
		{ "Shoulders of the Forlorn Protector", "Cho'gall or \"Essence of the Forlorn\" token", "Heroic" },
		{ "Chest of the Forlorn Protector", "Halfus Wyrmbreaker or \"Essence of the Forlorn\" token", "Heroic" },
		{ "Gauntlets of the Forlorn Protector", "Magmaw or \"Essence of the Forlorn\" token", "Heroic" },
		{ "Leggings of the Forlorn Protector", "Maloriak or \"Essence of the Forlorn\" token", "Heroic" },
		{ "Helm of the Forlorn Protector", "Nefarian", "Normal" },
		{ "Mantle of the Forlorn Protector", "Cho'gall", "Normal" }
	}
}

local Tier12Tokens = {
	DDMR = { --Death Knight, Druid, Mage, Rogue
		{ "Crown of the Fiery Vanquisher", "(Unknown)", "Heroic" },
		{ "Shoulders of the Fiery Vanquisher", "(Unknown)", "Heroic" },
		{ "Chest of the Fiery Vanquisher", "(Unknown)", "Heroic" },
		{ "Gauntlets of the Fiery Vanquisher", "(Unknown)", "Heroic" },
		{ "Leggings of the Fiery Vanquisher", "(Unknown)", "Heroic" },
		{ "Helm of the Fiery Vanquisher", "(Unknown)", "Normal" },
		{ "Mantle of the Fiery Vanquisher", "(Unknown)", "Normal" }
	},
	PPW = { --Paladin, Priest, Warlock
		{ "Crown of the Fiery Conqueror", "(Unknown)", "Heroic" },
		{ "Shoulders of the Fiery Conqueror", "(Unknown)", "Heroic" },
		{ "Chest of the Fiery Conqueror", "(Unknown)", "Heroic" },
		{ "Gauntlets of the Fiery Conqueror", "(Unknown)", "Heroic" },
		{ "Leggings of the Fiery Conqueror", "(Unknown)", "Heroic" },
		{ "Helm of the Fiery Conqueror", "(Unknown)", "Normal" },
		{ "Mantle of the Fiery Conqueror", "(Unknown)", "Normal" }
	},
	HSW = { --Hunter, Shaman, Warrior
		{ "Crown of the Fiery Protector", "(Unknown)", "Heroic" },
		{ "Shoulders of the Fiery Protector", "(Unknown)", "Heroic" },
		{ "Chest of the Fiery Protector", "(Unknown)", "Heroic" },
		{ "Gauntlets of the Fiery Protector", "(Unknown)", "Heroic" },
		{ "Leggings of the Fiery Protector", "(Unknown)", "Heroic" },
		{ "Helm of the Fiery Protector", "(Unknown)", "Normal" },
		{ "Mantle of the Fiery Protector", "(Unknown)", "Normal" }
	}
}
----------------------------------------------INSTANCES---------------------------------------------
local Raids = {
	"Firelands",
	"Baradin Hold",
	"Bastion of Twilight",
	"Blackwing Descent",
	"Throne of the Four Winds"
};

local HeroicDungeons = { --Heroic dungeons only
	"Zul'Aman",
	"Zul'Gurub",
	"The Deadmines",
	"Shadowfang Keep"
};

local Dungeons = { --Normal & Heroic dungeons
	"Throne of the Tides",
	"Blackrock Caverns",
	"The Stonecore",
	"The Vortex Pinnacle",
	"Lost City of Tol'vir",
	"Grim Batol",
	"Halls of Origination"
};
-----------------------------------------------BOSSES-----------------------------------------------
local FirelandsBosses = {
	"Beth'tilac",
	"Lord Rhyolith",
	"Alysrazor",
	"Shannox",
	"Baleroc",
	"Majordomo Staghelm",
	"Ragnaros",
	"(Trash Drop)"
};

local BaradinHoldBosses = {
	"Argaloth",
	"Occu'thar",
	"(Trash Drop)"
};

local BastionOfTwilightBosses = {
	"Halfus Wyrmbreaker",
	"Valiona & Theralion",
	"Ascendent Council",
	"Cho'gall",
	"Sinestra",
	"(Trash Drop)"
};

local BlackwingDescentBosses = {
	"Omnotron Defense System",
	"Magmaw",
	"Maloriak",
	"Atramedes",
	"Chimaeron",
	"Nefarian",
	"(Trash Drop)"
};

local ThroneOfTheFourWindsBosses = {
	"Conclave of Wind",
	"Al'Akir"
};

local ZulAmanBosses = {
	"Nalorakk",
	"Akil'zon",
	"Jan'alai",
	"Halazzi",
	"Hex Lord Malacrass",
	"Daakara",
	"(Timed Event)",
	"(Trash Drop)"
};

local ZulGurubBosses = {
	"High Priest Venoxis",
	"Bloodlord Mandokir",
	"High Priestess Kilnara",
	"Zanzil",
	"Jin'do the Godbreaker",
	"Gri'lek",
	"Hazza'rah",
	"Renataki",
	"Wushoolay",
	"(Trash Drop)"
};

local ThroneOfTidesBosses = {
	"Lady Naz'jar",
	"Commander Ulthok",
	"Mindbender Ghur'sha",
	"Ozumat",
	"(Trash Drop)"
};

local BlackrockCavernsBosses = {
	"Rom-ogg Bonecrusher",
	"Corla, Herald of Twilight",
	"Karsh Steelbender",
	"Beauty",
	"Ascendant Lord Obsidius",
	"(Trash Drop)"
};

local StonecoreBosses = {
	"Corborus",
	"Slabhide",
	"Ozruk",
	"High Priestess Azil",
	"(Trash Drop)"
};

local VortexPinnacleBosses = {
	"Grand Vizier Ertan",
	"Altairus",
	"Asaad",
	"(Trash Drop)"
};

local LostCityOfTolvirBosses = {
	"General Husam",
	"Augh and Lockmaw",
	"High Prophet Barim",
	"Siamat",
	"(Trash Drop)"
};

local GrimBatolBosses = {
	"General Umbriss",
	"Forgemaster Throngus",
	"Drahga Shadowburner",
	"Erudax",
	"(Trash Drop)"
};

local HallsOfOriginationBosses = {
	"Temple Guardian Anhuur",
	"Earthrager Ptah",
	"Anraphet",
	"Isiset",
	"Ammunae",
	"Setesh",
	"Rajh",
	"(Trash Drop)"
};

local DeadminesBosses = {
	"Glubtok",
	"Helix Gearbreaker",
	"Foe Reaper 5000",
	"Admiral Ripsnarl",
	"\"Captain\" Cookie",
	"Vanessa VanCleef",
	"(Trash Drop)"
};

local ShadowfangKeepBosses = {
	"Baron Ashbury",
	"Baron Silverlaine",
	"Commander Springvale",
	"Lord Walden",
	"Lord Godfrey",
	"(Trash Drop)"
};
--------------------------------------------CONSTRUCTORS--------------------------------------------
function UpgradeList:TopLevel(info, level)
	for i = 1, #GeneralItemLocations, 1 do
		info = UIDropDownMenu_CreateInfo()
		info.text = GeneralItemLocations[i]
		info.notCheckable = 1
		if info.text == "Other" then
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, "Other")
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = ""
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Other"
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = ""
				CloseDropDownMenus(1);
			end
			UIDropDownMenu_AddButton(info, level)
		else
			info.hasArrow = true
			info.value = info.text
			UIDropDownMenu_AddButton(info, level)
		end
	end
end

function UpgradeList:RaidSubmenu(info, level)
	for i = 1, #InstanceTypes, 1 do
		info.text = InstanceTypes[i]
		info.hasArrow = true
		info.value = InstanceTypes[i] .. "Raid"
		info.notCheckable = 1
		UIDropDownMenu_AddButton(info, level)
	end
end

function UpgradeList:DungeonSubmenu(info, level)
	for i = 1, #InstanceTypes, 1 do
		info.text = InstanceTypes[i]
		info.hasArrow = true
		info.value = InstanceTypes[i] .. "Dungeon"
		info.notCheckable = 1
		UIDropDownMenu_AddButton(info, level)
	end
end

function UpgradeList:CraftedSubmenu(info, level)
	for i = 1, #Professions, 1 do
		info.text = Professions[i]
		info.value = info.text
		info.notCheckable = true
		function info.func()
			UIDropDownMenu_SetText(DropDown_Button, Professions[i]);
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = ""
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = Professions[i];
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = ""
			CloseDropDownMenus(1);
		end
		UIDropDownMenu_AddButton(info, level)
	end
end

function UpgradeList:Reputations(info, level)
	for i = 1, #Reputations, 1 do
		info.text = Reputations[i]
		info.hasArrow = true
		info.value = info.text
		info.notCheckable = true
		UIDropDownMenu_AddButton(info, level)
	end
	if UnitFactionGroup("player") == "Alliance" then
		for i = 1, #AllianceReputations, 1 do
			info.text = AllianceReputations[i]
			info.hasArrow = true
			info.value = info.text
			info.notCheckable = true
			UIDropDownMenu_AddButton(info, level)
		end
	elseif UnitFactionGroup("player") == "Horde" then
		for i = 1, #HordeReputations, 1 do
			info.text = HordeReputations[i]
			info.hasArrow = true
			info.value = info.text
			UIDropDownMenu_AddButton(info, level)
		end
	else
		print("UpgradeList: Unable to determine your faction!")
	end
	if IsInGuild() then
		info.text = GetGuildInfo("player")
		info.hasArrow = true
		info.value = info.text
		info.notCheckable = 1
		UIDropDownMenu_AddButton(info, level)
	end
end

function UpgradeList:RepLevels(info, level, rep)
	for i = 1, #ReputationLevels, 1 do
		info.text = ReputationLevels[i]
		info.notCheckable = true
		function info.func()
			UIDropDownMenu_SetText(DropDown_Button, rep)
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = ReputationLevels[i]
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = reputation
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = ""
			CloseDropDownMenus(1);
		end
		UIDropDownMenu_AddButton(info, level)
	end
end

function UpgradeList:Purchasable(info, level)
	for i = 1, #Currency, 1 do
		info.text = Currency[i]
		info.value = info.text
		info.notCheckable = 1
		if Currency[i] == "Gear Token" then
			info.hasArrow = true
		else
			info.hasArrow = false
			function info.func()
				CloseDropDownMenus(1);
				UIDropDownMenu_SetSelectedName(DropDown_Button, Currency[i]);
				PointInput:Show();
				PointInputBox:SetFocus();
				UpgradeListMainFrame:EnableMouse(false)
				CloseButton:EnableMouse(false)
				ToggleButton:EnableMouse(false)
				UpgradeListDBVar.char.SavedOptions.PrimaryCheck:EnableMouse(false)
				UpgradeListDBVar.char.SavedOptions.SecondaryCheck:EnableMouse(false)
				OptionsFrame:EnableMouse(false)
				ItemEntryBox:EnableMouse(false)
				DropDown_Button:EnableMouse(false)
				NoteEntryBox:EnableMouse(false)
				PrimarySpecRadioButton:EnableMouse(false)
				SecondarySpecRadioButton:EnableMouse(false)
				priorityfield:EnableMouse(false)
				AddButton:EnableMouse(false)
				tofield:EnableMouse(false)
				fromfield:EnableMouse(false)
				MoveButton:EnableMouse(false)
				DeleteButton:EnableMouse(false)
				deletefield:EnableMouse(false)
			end
		end
		UIDropDownMenu_AddButton(info, level)
	end
end

function UpgradeList:HeroicRaids(info, level)
	for i = 1, #Raids, 1 do
		info.text = Raids[i]
		info.value = Raids[i] .. " Heroic"
		info.hasArrow = true
		info.notCheckable = 1
		UIDropDownMenu_AddButton(info, level)
	end
end

function UpgradeList:NormalRaids(info, level)
	for i = 1, #Raids, 1 do
		info.text = Raids[i]
		info.value = Raids[i] .. " Normal"
		info.hasArrow = true
		info.notCheckable = 1
		UIDropDownMenu_AddButton(info, level)
	end
end

function UpgradeList:HeroicDungeons(info, level)
	for i = 1, #HeroicDungeons, 1 do
		info.text = HeroicDungeons[i]
		info.value = HeroicDungeons[i] .. " Heroic"
		info.hasArrow = true
		info.notCheckable = 1
		UIDropDownMenu_AddButton(info, level)
	end
	for i = 1, #Dungeons, 1 do
		info.text = Dungeons[i]
		info.value = Dungeons[i] .. " Heroic"
		info.hasArrow = true
		info.notCheckable = 1
		UIDropDownMenu_AddButton(info, level)
	end
end

function UpgradeList:NormalDungeons(info, level)
	for i = 1, #Dungeons, 1 do
		info.text = Dungeons[i]
		info.value = Dungeons[i] .. " Normal"
		info.hasArrow = true
		info.notCheckable = 1
		UIDropDownMenu_AddButton(info, level)
	end
end

function UpgradeList:TierSelection(info, level)
	for i = 1, #TierTypes, 1 do
		info.text = TierTypes[i]
		info.value = TierTypes[i]
		info.hasArrow = true
		info.notCheckable = 1
		UIDropDownMenu_AddButton(info, level)
	end
end

function UpgradeList:GearTokens(info, level, tier)
	local _, englishClass = UnitClass("player");
	if tier == "Tier 11" then
		if (englishClass == "DEATHKNIGHT") or (englishClass == "DRUID") or (englishClass == "MAGE") or (englishClass == "ROGUE") then
			for i = 1, 7, 1 do
				info.text = Tier11Tokens.DDMR[i][1]
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, Tier11Tokens.DDMR[i][1])
					UpgradeListDBVar.char.SavedOptions.SelectedBoss = Tier11Tokens.DDMR[i][2]
					UpgradeListDBVar.char.SavedOptions.SelectedInstance = Tier11Tokens.DDMR[i][1]
					UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = Tier11Tokens.DDMR[i][3]
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
			end
		elseif (englishClass == "PALADIN") or (englishClass == "PRIEST") or (englishClass == "WARLOCK") then
			for i = 1, 7, 1 do
				info.text = Tier11Tokens.PPW[i][1]
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, Tier11Tokens.PPW[i][1])
					UpgradeListDBVar.char.SavedOptions.SelectedBoss = Tier11Tokens.PPW[i][2]
					UpgradeListDBVar.char.SavedOptions.SelectedInstance = Tier11Tokens.PPW[i][1]
					UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = Tier11Tokens.PPW[i][3]
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
			end
		elseif (englishClass == "HUNTER") or (englishClass == "SHAMAN") or (englishClass == "WARRIOR") then
			for i = 1, 7, 1 do
				info.text = Tier11Tokens.HSW[i][1]
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, Tier11Tokens.HSW[i][1])
					UpgradeListDBVar.char.SavedOptions.SelectedBoss = Tier11Tokens.HSW[i][2]
					UpgradeListDBVar.char.SavedOptions.SelectedInstance = Tier11Tokens.HSW[i][1]
					UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = Tier11Tokens.HSW[i][3]
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
			end
		end
	elseif tier == "Tier 12" then
		if (englishClass == "DEATHKNIGHT") or (englishClass == "DRUID") or (englishClass == "MAGE") or (englishClass == "ROGUE") then
			for i = 1, 7, 1 do
				info.text = Tier12Tokens.DDMR[i][1]
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, Tier12Tokens.DDMR[i][1])
					UpgradeListDBVar.char.SavedOptions.SelectedBoss = Tier12Tokens.DDMR[i][2]
					UpgradeListDBVar.char.SavedOptions.SelectedInstance = Tier12Tokens.DDMR[i][1]
					UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = Tier12Tokens.DDMR[i][3]
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
			end
		elseif (englishClass == "PALADIN") or (englishClass == "PRIEST") or (englishClass == "WARLOCK") then
			for i = 1, 7, 1 do
				info.text = Tier12Tokens.PPW[i][1]
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, Tier12Tokens.PPW[i][1])
					UpgradeListDBVar.char.SavedOptions.SelectedBoss = Tier12Tokens.PPW[i][2]
					UpgradeListDBVar.char.SavedOptions.SelectedInstance = Tier12Tokens.PPW[i][1]
					UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = Tier12Tokens.PPW[i][3]
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
			end
		elseif (englishClass == "HUNTER") or (englishClass == "SHAMAN") or (englishClass == "WARRIOR") then
			for i = 1, 7, 1 do
				info.text = Tier12Tokens.HSW[i][1]
				info.notCheckable = true
				function info.func()
					UIDropDownMenu_SetText(DropDown_Button, Tier12Tokens.HSW[i][1])
					UpgradeListDBVar.char.SavedOptions.SelectedBoss = Tier12Tokens.HSW[i][2]
					UpgradeListDBVar.char.SavedOptions.SelectedInstance = Tier12Tokens.HSW[i][1]
					UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = Tier12Tokens.HSW[i][3]
					CloseDropDownMenus(1);
				end
				UIDropDownMenu_AddButton(info, level)
			end
		end
	end
end

--RAIDS
function UpgradeList:Firelands(info, level, difficulty)
	for i = 1, #FirelandsBosses, 1 do
		info.text = FirelandsBosses[i]
		info.notCheckable = true
		function info.func()
			UIDropDownMenu_SetText(DropDown_Button, FirelandsBosses[i])
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = FirelandsBosses[i]
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Firelands"
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = difficulty
			CloseDropDownMenus(1);
		end
		UIDropDownMenu_AddButton(info, level)
	end
end

function UpgradeList:BaradinHold(info, level, difficulty)
	for i = 1, #BaradinHoldBosses, 1 do
		info.text = BaradinHoldBosses[i]
		info.notCheckable = true
		function info.func()
			UIDropDownMenu_SetText(DropDown_Button, BaradinHoldBosses[i])
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = BaradinHoldBosses[i]
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Baradin Hold"
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = difficulty
			CloseDropDownMenus(1);
		end
		UIDropDownMenu_AddButton(info, level)
	end
end

function UpgradeList:BastionOfTwilight(info, level, difficulty)
	if difficulty == "Normal" then
		for i = 1, 4, 1 do
			info.text = BastionOfTwilightBosses[i]
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, BastionOfTwilightBosses[i])
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = BastionOfTwilightBosses[i]
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Bastion of Twilight"
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = difficulty
				CloseDropDownMenus(1)
			end
			UIDropDownMenu_AddButton(info, level)
		end
		info.text = BastionOfTwilightBosses[6] --Trash Drop
		info.notCheckable = true
		function info.func()
			UIDropDownMenu_SetText(DropDown_Button, BastionOfTwilightBosses[6])
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = BastionOfTwilightBosses[6]
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Bastion of Twilight"
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = difficulty
			CloseDropDownMenus(1)
		end
		UIDropDownMenu_AddButton(info, level)
	else
		for i = 1, #BastionOfTwilightBosses, 1 do
			info.text = BastionOfTwilightBosses[i]
			info.notCheckable = true
			function info.func()
				UIDropDownMenu_SetText(DropDown_Button, BastionOfTwilightBosses[i])
				UpgradeListDBVar.char.SavedOptions.SelectedBoss = BastionOfTwilightBosses[i]
				UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Bastion of Twilight"
				UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = difficulty
				CloseDropDownMenus(1)
			end
			UIDropDownMenu_AddButton(info, level)
		end
	end
end

function UpgradeList:BlackwingDescent(info, level, difficulty)
	for i = 1, #BlackwingDescentBosses, 1 do
		info.text = BlackwingDescentBosses[i]
		info.notCheckable = true
		function info.func()
			UIDropDownMenu_SetText(DropDown_Button, BlackwingDescentBosses[i])
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = BlackwingDescentBosses[i]
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Blackwing Descent"
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = difficulty
			CloseDropDownMenus(1)
		end
		UIDropDownMenu_AddButton(info, level)
	end
end

function UpgradeList:ThroneOfTheFourWinds(info, level, difficulty)
	for i = 1, #ThroneOfTheFourWindsBosses, 1 do
		info.text = ThroneOfTheFourWindsBosses[i]
		info.notCheckable = true
		function info.func()
			UIDropDownMenu_SetText(DropDown_Button, ThroneOfTheFourWindsBosses[i])
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = ThroneOfTheFourWindsBosses[i]
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Throne of the Four Winds"
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = difficulty
			CloseDropDownMenus(1)
		end
		UIDropDownMenu_AddButton(info, level)
	end
end

--HEROIC ONLY DUNGEONS
function UpgradeList:ZulAman(info, level)
	for i = 1, #ZulAmanBosses, 1 do
		info.text = ZulAmanBosses[i]
		info.notCheckable = true
		function info.func()
			UIDropDownMenu_SetText(DropDown_Button, ZulAmanBosses[i])
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = ZulAmanBosses[i]
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Zul'Aman"
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic"
			CloseDropDownMenus(1)
		end
		UIDropDownMenu_AddButton(info, level)
	end
end

function UpgradeList:ZulGurub(info, level)
	for i = 1, #ZulGurubBosses, 1 do
		info.text = ZulGurubBosses[i]
		info.notCheckable = true
		function info.func()
			UIDropDownMenu_SetText(DropDown_Button, ZulGurubBosses[i])
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = ZulGurubBosses[i]
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Zul'Gurub"
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic"
			CloseDropDownMenus(1)
		end
		UIDropDownMenu_AddButton(info, level)
	end
end

function UpgradeList:Deadmines(info, level)
	for i = 1, #DeadminesBosses, 1 do
		info.text = DeadminesBosses[i]
		info.notCheckable = true
		function info.func()
			UIDropDownMenu_SetText(DropDown_Button, DeadminesBosses[i])
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = DeadminesBosses[i]
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Deadmines"
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic"
			CloseDropDownMenus(1)
		end
		UIDropDownMenu_AddButton(info, level)
	end
end

function UpgradeList:ShadowfangKeep(info, level)
	for i = 1, #ShadowfangKeepBosses, 1 do
		info.text = ShadowfangKeepBosses[i]
		info.notCheckable = true
		function info.func()
			UIDropDownMenu_SetText(DropDown_Button, ShadowfangKeepBosses[i])
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = ShadowfangKeepBosses[i]
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Shadowfang Keep"
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = "Heroic"
			CloseDropDownMenus(1)
		end
		UIDropDownMenu_AddButton(info, level)
	end
end

--DUNGEONS BOTH NORMAL & HEROIC
function UpgradeList:ThroneOfTides(info, level, difficulty)
	for i = 1, #ThroneOfTidesBosses, 1 do
		info.text = ThroneOfTidesBosses[i]
		info.notCheckable = true
		function info.func()
			UIDropDownMenu_SetText(DropDown_Button, ThroneOfTidesBosses[i])
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = ThroneOfTidesBosses[i]
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Throne of Tides"
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = difficulty
			CloseDropDownMenus(1)
		end
		UIDropDownMenu_AddButton(info, level)
	end
end

function UpgradeList:BlackrockCaverns(info, level, difficulty)
	for i = 1, #BlackrockCavernsBosses, 1 do
		info.text = BlackrockCavernsBosses[i]
		info.notCheckable = true
		function info.func()
			UIDropDownMenu_SetText(DropDown_Button, BlackrockCavernsBosses[i])
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = BlackrockCavernsBosses[i]
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Blackrock Caverns"
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = difficulty
			CloseDropDownMenus(1)
		end
		UIDropDownMenu_AddButton(info, level)
	end
end

function UpgradeList:Stonecore(info, level, difficulty)
	for i = 1, #StonecoreBosses, 1 do
		info.text = StonecoreBosses[i]
		info.notCheckable = true
		function info.func()
			UIDropDownMenu_SetText(DropDown_Button, StonecoreBosses[i])
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = StonecoreBosses[i]
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Stonecore"
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = difficulty
			CloseDropDownMenus(1)
		end
		UIDropDownMenu_AddButton(info, level)
	end
end

function UpgradeList:VortexPinnacle(info, level, difficulty)
	for i = 1, #VortexPinnacleBosses, 1 do
		info.text = VortexPinnacleBosses[i]
		info.notCheckable = true
		function info.func()
			UIDropDownMenu_SetText(DropDown_Button, VortexPinnacleBosses[i])
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = VortexPinnacleBosses[i]
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Vortex Pinnacle"
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = difficulty
			CloseDropDownMenus(1)
		end
		UIDropDownMenu_AddButton(info, level)
	end
end

function UpgradeList:LostCityOfTolvir(info, level, difficulty)
	for i = 1, #LostCityOfTolvirBosses, 1 do
		info.text = LostCityOfTolvirBosses[i]
		info.notCheckable = true
		function info.func()
			UIDropDownMenu_SetText(DropDown_Button, LostCityOfTolvirBosses[i])
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = LostCityOfTolvirBosses[i]
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Lost City of Tol'vir"
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = difficulty
			CloseDropDownMenus(1)
		end
		UIDropDownMenu_AddButton(info, level)
	end
end

function UpgradeList:GrimBatol(info, level, difficulty)
	for i = 1, #GrimBatolBosses, 1 do
		info.text = GrimBatolBosses[i]
		info.notCheckable = true
		function info.func()
			UIDropDownMenu_SetText(DropDown_Button, GrimBatolBosses[i])
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = GrimBatolBosses[i]
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Grim Batol"
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = difficulty
			CloseDropDownMenus(1)
		end
		UIDropDownMenu_AddButton(info, level)
	end
end

function UpgradeList:HallsOfOrigination(info, level, difficulty)
	for i = 1, #HallsOfOriginationBosses, 1 do
		info.text = HallsOfOriginationBosses[i]
		info.notCheckable = true
		function info.func()
			UIDropDownMenu_SetText(DropDown_Button, HallsOfOriginationBosses[i])
			UpgradeListDBVar.char.SavedOptions.SelectedBoss = HallsOfOriginationBosses[i]
			UpgradeListDBVar.char.SavedOptions.SelectedInstance = "Halls of Origination"
			UpgradeListDBVar.char.SavedOptions.SelectedDifficulty = difficulty
			CloseDropDownMenus(1)
		end
		UIDropDownMenu_AddButton(info, level)
	end
end